html, body {
    margin:0px;
    padding:0px;
}
html {
    background-color:#051505;
    overflow-x:hidden;
    min-height:100dvb;
}
* {
    color:white;
    font-family:Verdana, Geneva, Tahoma, sans-serif;
}
b, i, strong, em {
    color:#ddffdd;
}
code {
    font-family:'Courier New', Courier, monospace;
    background-color:black;
}
ul, li {
    margin-block-start:0px;
    margin-block-end:0px;
    margin:0px;
    padding-top:0px;
    padding-bottom:0px;
}
a {
    color:#00ff00;
    transition: 0.2s color;
}
sub {
    font-size:12px;
    color:#ddffdd;
    opacity:0.5;
    display:inline-block;
    transform:translateY(-40%);
}
.groupmenu {
    padding:0px;
    background-color:#051505;
    border:1px solid #00ff00;
    box-shadow:0px 0px 10px #00ff00;
    border-radius:12px;
}
.groupmenu div {
    font-size:14px;
    padding:5px; 
    font-weight:800;
    cursor:pointer;
    transition:0.2s background-color;
}
.groupmenu div:hover, .groupmenu div:active {
    background-color:#ffffff44;
}
a:active, a:hover {
    color:white;
}
button {
    border:none;
    outline:none;
    min-width: 70px;
    padding:4px;
    border-radius:4px;
    background-color:#00000022;
    cursor:pointer;
    transition:background-color 0.2s, box-shadow 0.2s, border-radius 0.2s; 
    box-shadow:0px 0px 1px white;
}
button:active, button:hover {
    background-color:#ffffff22;
    box-shadow:0px 0px 4px white;
    border-radius:8px;
}
button[disabled] {
    opacity:0.5;
    cursor:auto;
}
button[disabled]:active, button[disabled]:hover {
    background-color:#00000022;
    box-shadow:0px 0px 1px white;
    border-radius:4px;
}
.banner * {
    user-select:none;
}
.banner {
    position:absolute;
    display:flex;
    flex-flow:column;
    justify-content:center;
    width:calc(100% - 20px);
    height:40px;
    background-color:black;
    z-index:10000;
    border-bottom:1px solid #00ff00;
    box-shadow:0px 0px 10px #00ff00;
    border-radius:0px 0px 10px 10px;
    padding-left:10px;
    padding-right:10px;
}
.sendmessage {
    position:fixed;
    bottom:0px;
    width:calc(100% - 23px);
}
.messages {
    display:flex;
    flex-flow:column;
    overflow-y:auto;
    position:relative;
    top:0px;
    max-height:calc(100% - 204px);
    width:100%;
}
.messagebox {
    background-color:#00000044;
    border:2px solid transparent;
    border-radius:6px;
    width:inherit;
    padding:10px;
    margin-bottom:8px;
    min-height:30px;
    max-height:140px;
    height:30px;
    outline: none;
    transition:0.2s border, 0.2s box-shadow;
    box-shadow:0px 0px 4px #00ff00;
    font-size:14px;
    overflow-y:auto;
}
.attachmentbox {
    display:flex;
    flex-flow:row;
    position:absolute;
    bottom:100%;
    width:100%;
    background-color:#00000088;
    border-radius:8px 8px 0px 0px;
    overflow-x:auto;
}
.attachmentpreview {
    position:relative;
    padding:10px;
    margin:10px 0px 10px 10px;
    height: 200px;
    width: 250px;
    background-color:black;
}
.a {
    display:flex;
    flex-flow:row wrap;
    align-items:end;
    justify-content:space-between;
}
.preview {
    display:flex;
    flex-flow:column;
}
.preview * {
    object-fit:contain;
    max-height:250px;
}
.attachmentpreview *:not(p, i) {
    height:150px;
    width:inherit;
    object-fit:contain;
}
.attachmentpreview p {
    position:absolute;
    top:0px;
    right:0px;
    padding:0px;
    margin:0px;
    user-select:none;
    cursor:pointer;
}
.attachmentpreview i {
    display: inline-block;
    white-space:pre-wrap;
    width:inherit;
    text-align:center;
    font-size:12px;
}
#send {
    float:right;
}
.message {
    border-bottom:1px solid #ffffff88;
    margin-bottom:10px;
}
.message .x {
    opacity:0.5;
    display:inline;
    font-weight:800;
    border-radius:4px;
    border:2px solid red;
    cursor:pointer;
    color:red;
    font-size:12px;
    margin:0px 4px 10px 4px;
    padding:1px 6px 1px 6px;
    transition:0.2s opacity;
}
.message p.m, .message b.username {
    margin-left:4px;
}
.message p.m {
    white-space: pre-wrap;
    max-width:calc(100% - 20px);
    display:inline-block;
}
.message .x:active, .message .x:hover {
    opacity:1;
}
.messagebox:focus {
    box-shadow:0px 0px 4px transparent;
    border: 2px solid #00ff00;
}
.messagebox[disabled] {
    border:2px solid transparent;
    box-shadow:0px 0px 1px white;
    resize:none;
}
.typing {
    background-color:black;
    font-size:12px;
    color:white;
    font-style:italic;
    white-space:pre-wrap;
    word-wrap:break-word;
}
.sb {
    z-index:0;
    text-decoration:none;
    position:absolute;
    top:50px;
    width:calc(10% - 10px);
    aspect-ratio:1/5;
    object-fit:contain;
    border-radius:4px;
    border: 1px solid #00ff00;
    box-shadow:0px 0px 1px white;
}
input {
    color:black;
}
#groupName {
    user-select:none;
    display:flex;
    flex-flow:row wrap;
    align-items: center;
}
.groupIcon {
    width:64px;
    height:64px;
    margin-right:20px;
    margin-left:10px;
    border-radius:100px;
    box-shadow:0px 0px 10px #00ff00;
    object-fit:cover;
}
.group {
    cursor:pointer;
    font-size:14px;
    display:flex;
    flex-flow:row;
    align-items:center;
    transition:0.2s background-color;
    padding:4px;
    width:calc(100% - 8px);
    border-bottom:1px solid #ffffff88;
}
.groupform * {
    user-select:none;
}
.addGroup:active, .addGroup:hover {
    background-color:#ffffff44;
}
input[type="file"] {
    clip-path:polygon(0px 0px, 0px 50px, 96px 50px, 96px 0px);
}
.group b {
    word-wrap:break-word;
    white-space:pre-wrap;
}
.group:active, .group:hover, .group[selected] {
    background-color:#ffffff44;
}
.group img {
    height:32px;
    width:32px;
    margin:0px 10px 0px 10px;
}
div.sb {
    overflow-y:auto;
    flex-flow:column;
}
.container {
    display:flex;
    flex-flow:column;
    z-index:0;
    backdrop-filter:blur(3px);
    border:1px solid #00ff00;
    border-radius:10px;
    position:relative;
    background-color:#00000050;
    left:50%;
    top:50px;
    transform:translate(-50%, 0%);
    width:min(calc(80% - 24px), 1500px);
    height:max(200px, calc(100dvb - 76px));
    overflow-y:auto;
    padding:10px;
    margin:0px;
    box-shadow:0px 0px 10px #00ff00;
}
.loginform a, #signupform a {
    display:none;
}
#logout {
    position:sticky; top:calc(100% - 4px);
}
@media only screen and (max-device-width: 1150px){
    div.sb {
        flex-flow:row wrap;
        height:150px;
        width:100%;
        position:relative;
        top:50px;
    }
    .group {
        width: 100%;
    }
    .groupform {
        width:100%;
    }
    a.sb {
        display:none;
    }
    .sb hr {
        display:none;
    }
    #logout {
        top:50px;
        left:0px;
        order:10000;
    }
    .loginform {
        display:flex;
        flex-flow:column;
        align-items:center;
    }
    .loginform a, #signupform a {
        display:inline-block;
    }
    .loginform div {
        width:min(200px, 100%);
        display:flex;
        flex-flow:column;
        margin:20px 0px 20px 0px;
    }
    .container {
        width:calc(100% - 28px);
        height:calc(100dvb - 226px);
        min-height:300px;
    }
    #logout {
        width:100%;
        height:24px;
    }
}